Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/HDRFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/HDRFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/HDRFile.java	(revision 43867)
@@ -0,0 +1,128 @@
+
+package org.gvsig.fmap.dal.fileutils;
+
+import java.nio.ByteOrder;
+import org.gvsig.fmap.geom.primitive.Envelope;
+
+
+public interface HDRFile extends AuxFile {
+
+    public String FILE_EXTENSION = "hdr";
+    public String LAYOUT_BIL = "bil";
+    public String LAYOUT_BIP = "bip";
+    public String LAYOUT_BSQ = "bsq";
+    
+    public int NONE = -1;
+
+    public Envelope getEnvelope();
+    
+    public int getDataType();
+    
+    /**
+     * @return the bandgapbytes
+     */
+    public int getBandgapbytes();
+
+    /**
+     * @return the bandrowbytes
+     */
+    public int getBandrowbytes();
+
+    /**
+     * @return the byteorder
+     */
+    public ByteOrder getByteorder();
+
+    /**
+     * @return the comments
+     */
+    public String getComments();
+
+    /**
+     * @return the layout
+     */
+    public String getLayout();
+
+    /**
+     * @return the nbands
+     */
+    public int getNbands();
+
+    /**
+     * @return the nbits
+     */
+    public int getNbits();
+
+    /**
+     * @return the ncols
+     */
+    public int getNcols();
+
+    /**
+     * @return the nrows
+     */
+    public int getNrows();
+
+    /**
+     * @return the skipbytes
+     */
+    public int getSkipbytes();
+
+    /**
+     * @return the totalrowbytes
+     */
+    public int getTotalrowbytes();
+
+    /**
+     * @return the ulxmax
+     */
+    public double getUlxmax();
+
+    /**
+     * @return the ulymax
+     */
+    public double getUlymax();
+
+    /**
+     * @return the xdim
+     */
+    public double getXdim();
+
+    /**
+     * @return the ydim
+     */
+    public double getYdim();
+
+    /**
+     * @return the isValid
+     */
+    public boolean isValid();
+
+    /**
+     * @param comments the comments to set
+     */
+    public void setComments(String comments);
+
+    public int getBandSize();
+
+    /**
+     * @return the cellsize
+     */
+    public int getCellsize();
+
+    /**
+     * @return the nodata_value
+     */
+    public double getNodata_value();
+
+    /**
+     * @return the xllcorner
+     */
+    public double getXllcorner();
+
+    /**
+     * @return the yllcorner
+     */
+    public double getYllcorner();
+    
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/STXFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/STXFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/STXFile.java	(revision 43867)
@@ -0,0 +1,39 @@
+package org.gvsig.fmap.dal.fileutils;
+
+import java.util.List;
+
+public interface STXFile extends AuxFile {
+
+    public interface STXBand {
+        
+        public void parse(String line);
+
+        @Override
+        public String toString();
+        
+        public int getBand();
+        
+        public double getMinimum();
+        
+        public double getMaximum();
+        
+        public double getMean();
+        
+        public double getStdDeviation();
+        
+        public double getLinearStretchMin();
+        
+        public double getLinearStretchMax();
+
+        public boolean isValid();
+    }
+    
+    public String FILE_EXTENSION = "stx";
+
+    public void addBand(int band, double minimum, double maximum, double mean, double std_deviation, double linear_stretch_min, double linear_stretch_max);
+
+    public void clear();
+
+    public List<STXBand> getBands();
+   
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/CLRFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/CLRFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/CLRFile.java	(revision 43867)
@@ -0,0 +1,17 @@
+/*
+ * To change this license header, choose License Headers in Project Properties.
+ * To change this template file, choose Tools | Templates
+ * and open the template in the editor.
+ */
+package org.gvsig.fmap.dal.fileutils;
+
+import org.gvsig.raster.lib.legend.api.colortable.ColorTable;
+
+
+public interface CLRFile extends AuxFile {
+
+    ColorTable getColorTable();
+
+    void setColorTable(ColorTable colorTable);
+    
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/impl/DefaultHDRFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/impl/DefaultHDRFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/impl/DefaultHDRFile.java	(revision 43867)
@@ -0,0 +1,535 @@
+package org.gvsig.fmap.dal.fileutils.impl;
+
+import org.gvsig.fmap.dal.fileutils.HDRFile;
+import java.io.File;
+import java.nio.ByteOrder;
+import java.util.List;
+import java.util.logging.Level;
+import org.apache.commons.io.FileUtils;
+import org.apache.commons.io.FilenameUtils;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.GeometryLocator;
+import org.gvsig.fmap.geom.exception.CreateEnvelopeException;
+import org.gvsig.fmap.geom.primitive.Envelope;
+import org.gvsig.raster.lib.buffer.api.BufferManager;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+public class DefaultHDRFile implements HDRFile {
+
+    // http://resources.esri.com/help/9.3/arcgisdesktop/com/gp_toolref/spatial_analyst_tools/esri_ascii_raster_format.htm
+    private static final Logger logger = LoggerFactory.getLogger(DefaultHDRFile.class);
+
+    private File source;
+    private String comments;
+
+    private int nrows = NONE;
+    private int ncols = NONE;
+    private int nbands = 1;
+    private int nbits = 8;
+    private String pixeltype;
+    private String byteorder_word;
+    private ByteOrder byteorder = ByteOrder.nativeOrder();
+    private String layout = LAYOUT_BIL;
+    private int skipbytes = 0;
+    private double ulxmax = Double.NaN;
+    private double ulymax = Double.NaN;
+    private double xdim = Double.NaN;
+    private double ydim = Double.NaN;
+    private int bandrowbytes = NONE;
+    private int totalrowbytes = NONE;
+    private int bandgapbytes = 0;
+    private boolean valid = false;
+    private double nodata_value = Double.NaN;
+
+    // X coordinate of the origin (by center or lower left corner of the cell).
+    private double xllcorner = Double.NaN;
+
+    // Y coordinate of the origin (by center or lower left corner of the cell).
+    private double yllcorner = Double.NaN;
+
+    private int cellsize = NONE;
+
+    public DefaultHDRFile() {
+        this.source = null;
+    }
+
+    @SuppressWarnings("OverridableMethodCallInConstructor")
+    public DefaultHDRFile(File file) {
+        this();
+        this.read(file);
+    }
+
+    @Override
+    public File getFile(File file) {
+        File f = new File(FilenameUtils.removeExtension(file.getAbsolutePath()) + "." + FILE_EXTENSION);
+        return f;
+    }
+
+    @Override
+    public File getFile() {
+        return source;
+    }
+
+    @Override
+    public void read(File file) {
+        File f = this.getFile(file);
+        if (f.exists()) {
+            try {
+                List<String> lines = FileUtils.readLines(f);
+                if (lines != null) {
+                    this.source = f.getAbsoluteFile();
+                    int lineno = 1;
+                    for (String line : lines) {
+                        String[] words = StringUtils.split(line.trim().toLowerCase());
+                        try {
+                            switch (words[0]) {
+                                case "nrows":
+                                    this.nrows = Integer.parseUnsignedInt(words[1]);
+                                    break;
+                                case "ncols":
+                                    this.ncols = Integer.parseUnsignedInt(words[1]);
+                                    break;
+                                case "nbands":
+                                    this.nbands = Integer.parseUnsignedInt(words[1]);
+                                    break;
+                                case "nbits":
+                                    this.nbits = Integer.parseUnsignedInt(words[1]);
+                                    break;
+                                case "pixeltype":
+                                    this.pixeltype = words[1];
+                                    break;
+                                case "byteorder":
+                                    this.byteorder_word = words[1];
+                                    break;
+                                case "layout":
+                                    this.layout = words[1];
+                                    break;
+                                case "skipbytes":
+                                    this.skipbytes = Integer.parseUnsignedInt(words[1]);
+                                    break;
+                                case "nodata_value":
+                                    this.nodata_value = Double.parseDouble(words[1]);
+                                    break;
+                                case "cellsize":
+                                    this.cellsize = Integer.parseUnsignedInt(words[1]);
+                                    break;
+                                case "xllcorner":
+                                case "xllcenter":
+                                    this.xllcorner = Double.parseDouble(words[1]);
+                                    break;
+                                case "yllcorner":
+                                case "yllcenter":
+                                    this.yllcorner = Double.parseDouble(words[1]);
+                                    break;
+                                case "ulxmax":
+                                    this.ulxmax = Double.parseDouble(words[1]);
+                                    break;
+                                case "ulymax":
+                                    this.ulymax = Double.parseDouble(words[1]);
+                                    break;
+                                case "xdim":
+                                    this.xdim = Double.parseDouble(words[1]);
+                                    break;
+                                case "ydim":
+                                    this.ydim = Double.parseDouble(words[1]);
+                                    break;
+                                case "bandrowbytes":
+                                    this.bandrowbytes = Integer.parseUnsignedInt(words[1]);
+                                    break;
+                                case "totalrowbytes":
+                                    this.totalrowbytes = Integer.parseUnsignedInt(words[1]);
+                                    break;
+                                case "bandgapbytes":
+                                    this.bandgapbytes = Integer.parseUnsignedInt(words[1]);
+                                    break;
+                            }
+                        } catch (NumberFormatException e) {
+                            logger.warn("Can't parse keyword '" + words[0]
+                                    + "' (value='" + words[1]
+                                    + "', lineno=+" + lineno
+                                    + ", file=" + f.getAbsoluteFile()
+                                    + ").", e);
+                        }
+                        lineno++;
+                    }
+                    this.fixValues();
+                }
+
+            } catch (Exception e) {
+                logger.warn("Couldn't read " + FILE_EXTENSION + " file (" + f.getAbsoluteFile() + ")", e);
+            }
+        }
+    }
+
+    private void fixValues() {
+        @SuppressWarnings("LocalVariableHidesMemberVariable")
+        boolean valid = true;
+
+        if (this.pixeltype != null) {
+            switch (this.pixeltype) {
+                case "signedint":
+                    this.nbits = 32;
+                    break;
+                case "byte_unsigned":
+                    this.nbits = 8;
+                    break;
+            }
+        }
+
+        switch (this.getNbits()) {
+            case 1:
+            case 4:
+                logger.warn("nbits keyword has a non supported value of " + this.getNbits() + " (" + this.source.getAbsolutePath() + ").");
+                valid = false;
+                break;
+            case 8:
+            case 16:
+            case 32:
+            case 64:
+                break;
+            default:
+                logger.warn("nbits keyword has an invalid value of " + this.getNbits() + " (" + this.source.getAbsolutePath() + ").");
+                this.nbits = 1;
+                valid = false;
+                break;
+        }
+
+        switch (this.getLayout()) {
+            case LAYOUT_BIL:
+            case LAYOUT_BIP:
+            case LAYOUT_BSQ:
+                break;
+            default:
+                logger.warn("layout keyword has an invalid value of '" + this.getLayout() + "' (" + this.source.getAbsolutePath() + ").");
+                this.layout = LAYOUT_BIL;
+                valid = false;
+                break;
+        }
+
+        if( StringUtils.isEmpty(this.byteorder_word) ) {
+            this.byteorder = ByteOrder.nativeOrder();
+            if( this.byteorder == ByteOrder.BIG_ENDIAN ) {
+                this.byteorder_word = "msbfirst";
+            } else {
+                this.byteorder_word = "lsbfirst";
+            }
+        } else {
+            switch(this.byteorder_word) {
+                case "lsbfirst":
+                case "little_endian":
+                case "littleendian":
+                case "intel":
+                case "i":
+                    this.byteorder = ByteOrder.LITTLE_ENDIAN;
+                    break;
+                case "motorola":
+                case "m":
+                case "msbfirst":
+                case "big_endian":
+                case "bigendian":
+                    this.byteorder = ByteOrder.BIG_ENDIAN;
+                    break;
+                default:
+                    logger.warn("byteorder keyword has an invalid value of '" + this.byteorder_word + "' (" + this.source.getAbsolutePath() + ").");
+                    this.byteorder = ByteOrder.nativeOrder();
+            }
+        }
+        if (this.getNrows() == NONE || this.getNcols() == NONE) {
+            logger.warn("nrows/ncols keywords has an invalid value of '" + this.getNrows() + "/" + this.getNcols() + "' (" + this.source.getAbsolutePath() + ").");
+            valid = false;
+        }
+        if (this.getUlymax() == NONE) {
+            this.ulymax = this.getNrows() - 1;
+        }
+        if (this.getBandrowbytes() == NONE) {
+            this.bandrowbytes = (this.getNcols() * this.getNbits()) / 8;
+        }
+        switch (this.getLayout()) {
+            case LAYOUT_BIL:
+                if (this.getTotalrowbytes() == NONE) {
+                    this.totalrowbytes = this.getNbands() * this.getBandrowbytes();
+                }
+                this.bandgapbytes = 0;
+                break;
+            case LAYOUT_BIP:
+                if (this.getTotalrowbytes() == NONE) {
+                    this.totalrowbytes = (this.getNcols() * this.getNbands() * this.getNbits()) / 8;
+                }
+                this.bandgapbytes = 0;
+                break;
+            case LAYOUT_BSQ:
+                if (this.getTotalrowbytes() == NONE) {
+                    this.totalrowbytes = 0;
+                }
+                if (this.getBandgapbytes() == NONE) {
+                    this.bandgapbytes = 0;
+                }
+                break;
+        }
+        this.valid = valid;
+    }
+
+    @Override
+    public int getDataType() {
+        if (this.pixeltype != null) {
+            switch (this.pixeltype) {
+                case "signedint":
+                    return BufferManager.TYPE_INT;
+                case "byte_unsigned":
+                    return BufferManager.TYPE_BYTE;
+            }
+        }
+        switch (this.getNbits()) {
+            case 1:
+            case 4:
+            default:
+                return BufferManager.TYPE_UNDEFINED;
+            case 8:
+                return BufferManager.TYPE_BYTE;
+            case 16:
+                return BufferManager.TYPE_USHORT;
+            case 32:
+                return BufferManager.TYPE_INT;
+            case 64:
+                return BufferManager.TYPE_DOUBLE;
+        }
+    }
+
+    @Override
+    public void write(File file) {
+        // TODO: falta implementar el write del hdr
+        File f = this.getFile(file);
+    }
+
+    @Override
+    public Envelope getEnvelope() {
+        Envelope envelope = null;
+        try {
+            if (!Double.isNaN(this.xllcorner)
+                    && !Double.isNaN(this.yllcorner)
+                    && this.cellsize > 0) {
+                envelope = GeometryLocator.getGeometryManager().createEnvelope(
+                        this.xllcorner,
+                        this.yllcorner,
+                        this.xllcorner + (this.ncols * this.cellsize),
+                        this.yllcorner + (this.nrows * this.cellsize),
+                        Geometry.SUBTYPES.GEOM2D);
+            }
+            if (envelope == null && !Double.isNaN(this.ulxmax)
+                    && !Double.isNaN(this.ulymax)
+                    && !Double.isNaN(this.xdim)
+                    && !Double.isNaN(this.ydim)) {
+                envelope = GeometryLocator.getGeometryManager().createEnvelope(
+                        this.ulxmax,
+                        this.ulymax - (this.nrows * this.ydim),
+                        this.ulxmax + (this.ncols * this.xdim),
+                        this.ulymax,
+                        Geometry.SUBTYPES.GEOM2D);
+            }
+            if (envelope == null && !Double.isNaN(this.xdim)
+                    && !Double.isNaN(this.ydim)) {
+                envelope = GeometryLocator.getGeometryManager().createEnvelope(
+                        0,
+                        0,
+                        this.ncols * this.xdim,
+                        this.nrows * this.ydim,
+                        Geometry.SUBTYPES.GEOM2D);
+            }
+            if (envelope == null && this.cellsize > 0) {
+                envelope = GeometryLocator.getGeometryManager().createEnvelope(
+                        0,
+                        0,
+                        this.ncols * this.cellsize,
+                        this.nrows * this.cellsize,
+                        Geometry.SUBTYPES.GEOM2D);
+            }
+            if (envelope == null) {
+                envelope = GeometryLocator.getGeometryManager().createEnvelope(
+                        0,
+                        0,
+                        this.ncols,
+                        this.nrows,
+                        Geometry.SUBTYPES.GEOM2D);
+            }
+        } catch (Exception ex) {
+            logger.debug("Can't calculate envelope.", ex);
+        }
+        return envelope;
+    }
+
+    /**
+     * @return the nrows
+     */
+    @Override
+    public int getNrows() {
+        return nrows;
+    }
+
+    /**
+     * @return the ncols
+     */
+    @Override
+    public int getNcols() {
+        return ncols;
+    }
+
+    /**
+     * @return the nbands
+     */
+    @Override
+    public int getNbands() {
+        return nbands;
+    }
+
+    /**
+     * @return the nbits
+     */
+    @Override
+    public int getNbits() {
+        return nbits;
+    }
+
+    /**
+     * @return the byteorder
+     */
+    @Override
+    public ByteOrder getByteorder() {
+        return byteorder;
+    }
+
+    /**
+     * @return the layout
+     */
+    @Override
+    public String getLayout() {
+        return layout;
+    }
+
+    /**
+     * @return the skipbytes
+     */
+    @Override
+    public int getSkipbytes() {
+        return skipbytes;
+    }
+
+    /**
+     * @return the ulxmax
+     */
+    @Override
+    public double getUlxmax() {
+        return ulxmax;
+    }
+
+    /**
+     * @return the ulymax
+     */
+    @Override
+    public double getUlymax() {
+        return ulymax;
+    }
+
+    /**
+     * @return the xdim
+     */
+    @Override
+    public double getXdim() {
+        return xdim;
+    }
+
+    /**
+     * @return the ydim
+     */
+    @Override
+    public double getYdim() {
+        return ydim;
+    }
+
+    /**
+     * @return the bandrowbytes
+     */
+    @Override
+    public int getBandrowbytes() {
+        return bandrowbytes;
+    }
+
+    /**
+     * @return the totalrowbytes
+     */
+    @Override
+    public int getTotalrowbytes() {
+        return totalrowbytes;
+    }
+
+    /**
+     * @return the bandgapbytes
+     */
+    @Override
+    public int getBandgapbytes() {
+        return bandgapbytes;
+    }
+
+    /**
+     * @return the isValid
+     */
+    @Override
+    public boolean isValid() {
+        return valid;
+    }
+
+    /**
+     * @return the comments
+     */
+    @Override
+    public String getComments() {
+        return comments;
+    }
+
+    /**
+     * @param comments the comments to set
+     */
+    @Override
+    public void setComments(String comments) {
+        this.comments = comments;
+    }
+
+    /**
+     * @return the nodata_value
+     */
+    @Override
+    public double getNodata_value() {
+        return nodata_value;
+    }
+
+    /**
+     * @return the xllcorner
+     */
+    @Override
+    public double getXllcorner() {
+        return xllcorner;
+    }
+
+    /**
+     * @return the yllcorner
+     */
+    @Override
+    public double getYllcorner() {
+        return yllcorner;
+    }
+
+    /**
+     * @return the cellsize
+     */
+    @Override
+    public int getCellsize() {
+        return cellsize;
+    }
+
+    @Override
+    public int getBandSize() {
+        return (this.nrows * this.ncols * this.nbits) + this.bandgapbytes;
+    }
+
+}
